/* Répond aux messages de lecture / définition d'options. */
browser.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if (request.mode == 'get') {
        var options = ('options' in request.data) ? request.data.options : undefined
        readUserOptions(request.data.id, options, function(data, error) {
            sendResponse( (typeof data === 'undefined') ?
                {good: false, error: error, id: request.id} :
                {good: true, data: data, id: request.id} )
        })
        
    } else if (request.mode == 'set') {
        browser.storage.local.set(request.data).then(
			function() { sendResponse({good: true, data: true, id: request.id}) },
			function(error) {
                console.log(error)
                sendResponse({good: false, error: error, id: request.id})
            }
		)
    }
    return true
})