﻿readOptions(function(response) {
    if (typeof response ==='undefined') return;

    /* Détection de la page du jeu : on ne veut s'occuper que de la vue ou
       de la page de connexion (après identification) */
    var page = document
    var regex = new RegExp( "[\\?&]p=([^&#]*)" )
    var results = regex.exec(page.location.toString())
    if( results == null || (results[1] != 'vue' && results[1] != 'tourdejeu') ) return

    /* Récupère sur la page de vue les coordonnées et l'identifiant du
       personnage du joueur, puis lit les préférences de cet utilisateur
       et enfin envoie la requête de chargement du code distant de l'extension.
     */
    function extractInfos(page)
    {
        /* Extraction des coordonnées du centre de la vue */
        var coords = document.evaluate("/html/body/div[@class='affichage_session']/p/span[@class='margin_position']",
            document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE,null).iterateNext()
        if (coords == null || coords.childNodes.length < 2) return false
        
        var regExp = /.*X:(.*) \| Y:(.*)$/i
        matches = regExp.exec(coords.childNodes[1].textContent)
        if(matches == null || typeof matches[1] == "undefined" || typeof matches[2] == "undefined") return false
        
        var x = parseInt(matches[1])
        var y = parseInt(matches[2])
        
        /* Extraction de l'id et du nom du personnage*/
        var parentSpan = document.evaluate("/html/body/div[@class='affichage_session']/div[@class='inline']/span/strong",
            document, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE,null).iterateNext()
        if (parentSpan == null) return false
        
        regExp = /\((\d+)\)/i
        var spanId = document.evaluate("./span[contains(translate(normalize-space(@style), ' ', ''), 'display:none')]",
            parentSpan, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE,null).iterateNext()        
        if (spanId == null) return false
        matches = regExp.exec(spanId.textContent)
        if(matches == null || typeof matches[1] == "undefined") return false
        var id = parseInt(matches[1])
        
        var params = '&x=' + x + '&y=' + y + '&id=' + id
        readUserOptions(id, null, function(data, error) {
            if (data == undefined) return callServer(page, '')
            for (var k in data) {
                v = data[k]
                if (v == null) v = ''
                if (k == 'akey') k = 'code'
                params += '&' + k + '=' + v
            }
            callServer(page, params)
        })
        return true
    }
    
    /* Appelle le script à injecter depuis le serveur.
     L'argument <parameters> permet de définir des arguments supplémentaires.
     Ceux-ci consisteront en les options utilisateur - lié à son personnage.
     */
    function callServer(page, parameters)
    {
        /* Variables globales pour le fonctionnement du script : les options */

        /* URL du site externe de stockage de données de vues (le site KiCarte) */
        var kicarteURLScripts = response.scriptsURL + 'content/'

        var urlsOptions = '?mode=chargement'
        urlsOptions += '&path=' + escape(kicarteURLScripts)
        /* Options et informations standard de l'extension */
        /* Version actuelle de l'extension */
        var parts = response.version.split('.')
        var ver = parseFloat(parts[0]) + parts[1] / 10.0 + parts[2] / 100.0
        urlsOptions += '&version=' + escape(ver)
        /* Système cartographique privé destinataire de la vue */
        urlsOptions += '&system=' + escape(response.system)
        /* Option d'envoi de la vue au système public */
        urlsOptions += '&toPublic=' + response.toPublic
        /* Envoi automatique de la vue (par défaut : envoi manuel) */
        urlsOptions += '&autoSend=' + response.autoSend
        /* Mode debug */
        urlsOptions += '&debug=' + response.debug
        /* Information sur l'existence d'une nouvelle version de l'extension */
        urlsOptions += '&checkUpdate=' + response.update

        /* Appel du script de traitement distant (option avancée) */
        if (response.jqueryAtStart)
        {
            /* Appel jQuery (implique le chargement de jQuery avant exécution de cette extension */
            $.getScript(kicarteURLScripts + 'kicarte.php' + urlsOptions + parameters)
        } else {
            /* Méthode traditionnelle équivalente */
            var scriptJS = page.createElement('script')
            scriptJS.id = 'kicarteScript'
            scriptJS.language = 'JavaScript'
            scriptJS.charset = 'UTF-8'
            scriptJS.async = true
            scriptJS.type = 'text/javascript'
            /* URL d'appel pour l'extension - 'Math.random()' est là pour
               contourner le phénomène de mise en cache du navigateur */
            scriptJS.src = kicarteURLScripts + 'kicarte.php' + urlsOptions + parameters + '&rnd=' + Math.random()
            page.body.appendChild(scriptJS)
        }
        return true
    }
    
    /* Passe-plat : la réception d'événements provenant de la page pour
       est transmis à l'extension par la messagerie :
       événement de la page => appel de sendMessage,
       réponse de sendMessage => événement retour.*/
    function notifyOptions(mode, event)
    {
        var detail = event.detail
        function respond(response)
        {
            var target = window.document.defaultView
            var responseDetail = cloneInto({detail: response}, target)
            window.document.dispatchEvent(new target.CustomEvent(detail.target, responseDetail))
        }
        
        browser.runtime.sendMessage({
            mode: mode,
            target: detail.target,
            id: detail.id,
            data: detail.data
        }).then(
            respond,
            function(error) {
                console.log(error)
                respond( {good: false, error: error, id: detail.id} )
            }
        )
    }
    
    /* Sur la page de vue, on va tenter de récupérer les préférences
       utilisateur pour les appliquer sur cette page.
       Sur une autre page, traitement par défaut. */
    if(results[1] != 'vue' || !extractInfos(page))
        callServer(page, '')
    
    /* Branchement des événements de lecture / mise à jour des options sur le passe-plat. */
    window.document.addEventListener("kicarteSetOptions", function(e) { notifyOptions('set', e) })
    window.document.addEventListener("kicarteGetOptions", function(e) { notifyOptions('get', e) })
})
