﻿var currentOptions = {};

/* Met à jour les champs de la fenêtre d'options */
function setOptions(options)
{
    document.getElementById('system').value = options.system;
    document.getElementById('topublic').checked = options.toPublic;
    document.getElementById('autosend').checked = options.autoSend;
    document.getElementById('debug').checked = options.debug;
    document.getElementById('update').checked = options.update;
    
    document.getElementById('jquery').checked = options.jqueryAtStart;
    document.getElementById('kcscripts').value = options.scriptsURL;
}

/* Remet les valeurs par défaut dans la fenêtre d'options */
function setDefault() {
    setOptions(defaultValues());
}

/* Relit les options actuelles */
function restoreOptions()
{
    readOptions(function(options) {
        if (typeof options === 'undefined')
        {
            /* Notification dans la barre de statut. */
            var status = document.getElementById('status');
            status.textContent = browser.i18n.getMessage('optionsError');
            setTimeout(function() {
                status.innerHTML = '&nbsp;';
            }, 2000);
        } else {
            currentOptions = options;
            setOptions(options)
        }
    });
}

/* Sauvegarde les options au sein de browser.storage.local */
function saveOptions() {
    var options = currentOptions;
    options.system = document.getElementById('system').value;
    options.toPublic = document.getElementById('topublic').checked;
    options.autoSend = document.getElementById('autosend').checked;
    options.debug = document.getElementById('debug').checked;
    options.update = document.getElementById('update').checked;
    
    var advancedOptions = document.getElementsByClassName('advanced');
    if (advancedOptions != null && advancedOptions.length > 0 && advancedOptions[0].style.display != 'none')
    {
        options.jqueryAtStart = document.getElementById('jquery').checked;
        options.scriptsURL = document.getElementById('kcscripts').value;
    }
    
    browser.storage.local.set(options, function() {
        /* Notification dans la barre de statut. */
        var status = document.getElementById('status');
        status.textContent = browser.i18n.getMessage('optionsSaved');
        setTimeout(function() {
            status.innerHTML = '&nbsp;';
        }, 750);
    });
}

/* Ferme la fenêtre */
function closeOptions()
{
    window.close()
}

/* Traduit les textes sur la page d'options */
function localizePage()
{
    /* Recherche et remplace les marqueurs __MSG_***__ */
    var objects = document.getElementsByTagName('html');
    for (var j = 0; j < objects.length; j++)
    {
        var obj = objects[j];

        var tagged = obj.innerHTML.toString();
        var localized = tagged.replace(/__MSG_(\w+)__/g, function(match, value)
        {
            return value ? browser.i18n.getMessage(value) : "";
        });

        if(localized != tagged)
        {
            obj['innerHTML'] = localized;
        }
    }
}

/* Affiche les options avancées de l'extension (plutôt pour développeur) */
function toggleAdvanced()
{
    var advancedOptions = document.getElementsByClassName('advanced');
    if (advancedOptions == null || advancedOptions.length < 1) return
    var display = advancedOptions[0].style.display != 'none' ? 'none' : '';
    for (var i = 0; i < advancedOptions.length; i++) {
        advancedOptions[i].style.display = display;
    }
}

/* Chargement de la fenêtre d'options : internationalisation,
   événements sur boutons, chargement des options */
{
    localizePage();
    toggleAdvanced();
    document.getElementById('default').addEventListener('click', setDefault);
    document.getElementById('save').addEventListener('click', saveOptions);
    document.getElementById('close').addEventListener('click', closeOptions);
    document.getElementById('devmode').addEventListener('click', toggleAdvanced);
    document.addEventListener('DOMContentLoaded', restoreOptions);
}
